NETSTAT(8)

NAME
netstat - show network status

SYNOPSIS
netstat [ -Aan ] [ -f address_family ] [ system ] [ core ]
netstat [ -himnrs ] [ -f address_family ] [ system ] [ core ]
netstat [ -n ] [ -I interface ] interval [ system ] [ core ]

DESCRIPTION

The netstat command symbolically displays the contents of various network-related data structures. There are a number of output formats, depending on the options for the information presented. The first form of the command displays a list of active sockets for each protocol. The second form presents the contents of one of the other network data structures according to the option selected. Using the third form, with an interval specified, netstat will continuously display the information regarding packet traffic on the configured network interfaces. The display formats are controlled by the options listed below and are described in the DISPLAYS section below.

The arguments system and core allow substitutes for the defaults ``/vmunix'' and ``/dev/kmem''.

OPTIONS
The options have the following meaning.

-A  With the default display, show the address of any protocol control blocks associated with sockets; used for debugging.

-a  With the default display, show the state of all sockets; normally sockets used by server processes are not shown.

-f address_family
    Limit statistics or address control block reports to those of the specified address family. The following address families are recognized: inet, for AF_INET, and unix, for AF_UNIX.

-h  Show the state of the IMP host table. This does not work in an environment where the IMP host tables do not exist.

-i  Show the state of interfaces that have been auto-configured. (Interfaces statically configured into a system, but not located at boot time are not shown.)

-I interface
    Show information only about this interface; used with an interval as described below.

-m  Show statistics recorded by the memory management routines. (The network manages a private pool of memory buffers.)

-n  Show network addresses as numbers. (Normally netstat interprets addresses and attempts to display them symbolically.) This option may be used with any of the display formats.

-s  Show per-protocol statistics. When used with the -r option, the -s option displays routing statistics.

-r  Show the routing tables. When -s is also present, show routing statistics instead.

-t  In the interface display, replace queue length information with timer information.

In its second form of invocation netstat checks its options in the order -m, -i, -h, and -r and presents a display for only one of these options.

DISPLAYS
The default display, for active sockets, shows the local and remote addresses, send and receive queue sizes (in bytes), protocol, and the internal state of the protocol. Address formats are of the form ``host.port,'' or ``network.port'' if a socket's address specifies a network but no specific host address. When known, the host and network addresses are displayed symbolically according to the data bases /etc/hosts and /etc/networks, respectively. If a symbolic name for an address is unknown, or if the -n option is specified, the address is printed numerically, according to the address family. For more information regarding the Internet ``dot format,'' refer to inet(3N). Unspecified, or ``wildcard'', addresses and ports appear as ``*''.

The possible state values for TCP sockets are as follows.

    CLOSED
        Closed: socket not being used

    LISTEN
        Listening for incoming connections

    SYN_SENT
        Actively trying to establish connection

    SYN_RECEIVED
        Initial synchronization of the connection

    ESTABLISHED
        Connection has been established

    CLOSE_WAIT
        Remote shut down, waiting for socket to close

    FIN_WAIT_1
        Socket closed, shutting down connection

    CLOSING
        Closed, then remote shutdown, awaiting acknowledgement

    LAST_ACK
        Remote shut down, then closed, awaiting acknowledgement

    FIN_WAIT_2
        Socket closed, waiting for shutdown from remote

    TIME_WAIT
        Wait after close for remote shutdown retransmission

The interface display provides a table of cumulative statistics regarding packets transferred, errors, and collisions. The network addresses of the interface and the maximum transmission unit (``mtu'') are also displayed.

The routing table display indicates the available routes and their status. Each route consists of a destination host or network and a gateway to use in forwarding packets. The flags field shows the state of the route (``U'' if ``up''), whether the route is to a gateway (``G''), and whether the route was created dynamically by a redirect (``D''). Direct routes are created for each interface attached to the local host; the gateway field for such entries shows the address of the outgoing interface. The refcnt field gives the current number of active uses of the route. Connection-oriented protocols normally hold on to a single route for the duration of a connection whereas connectionless protocols obtain a route while sending to the same destination. The use field provides a count of the number of packets sent using that route. The interface entry indicates the network interface utilized for the route.

When netstat is invoked with an interval argument, it displays a running count of statistics related to network interfaces. This display consists of a column summarizing information for all interfaces, and a column for the interface with the most traffic since the system was last rebooted. The most heavily travelled interface may be replaced with another interface with the -I option. Every 24th line of the display contains a summary since the system was last rebooted. Subsequent lines of output show values accumulated over the preceding interval.

SEE ALSO
iostat(8), vmstat(8), hosts(5), networks(5), protocols(5), services(5), trpt(8C)

BUGS
The notion of errors is ill-defined. Collisions mean something else for the IMP.

The kernel's tables can change while netstat is examining them, creating incorrect or partial displays.